'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _SkinnableComponent2 = require('./SkinnableComponent');

var _SkinnableComponent3 = _interopRequireDefault(_SkinnableComponent2);

var _events = require('../utils/events');

var _events2 = _interopRequireDefault(_events);

var _props = require('../utils/props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Options = (_temp2 = _class = function (_SkinnableComponent) {
  _inherits(Options, _SkinnableComponent);

  function Options() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Options);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Options.__proto__ || Object.getPrototypeOf(Options)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isOpen: _this.props.isOpen,
      highlightedOptionIndex: 0,
      position: null
    }, _this.updateComponentsStates = function (isOpen, position) {
      _this.setState({ isOpen: isOpen, position: position });
    }, _this.getFirstScrollableParent = function (node) {
      if (node == null) return null;
      if (node.scrollHeight > node.clientHeight) {
        return node;
      } else {
        return _this.getFirstScrollableParent(node.parentNode);
      }
    }, _this.handleScrollEventListener = function (action) {
      var rootNode = _this._getRootSkinPart();
      var scrollableNode = _this.getFirstScrollableParent(rootNode);
      if (scrollableNode) {
        if (action === 'add') {
          scrollableNode.addEventListener('scroll', _this._handleScroll);
        } else if (action === 'remove') {
          scrollableNode.addEventListener('scroll', _this._handleScroll);
        }
      }
    }, _this.open = function () {
      _this.setState({
        isOpen: true,
        highlightedOptionIndex: _this.props.resetOnClose ? 0 : _this.state.highlightedOptionIndex
      });
    }, _this.close = function () {
      if (_this.props.onClose) _this.props.onClose();
      _this.setState({
        position: null,
        highlightedOptionIndex: _this.props.resetOnClose ? 0 : _this.state.highlightedOptionIndex
      });
    }, _this.getHighlightedOptionIndex = function () {
      // If nothing is higlighted, highlight selected option
      // In case nothing is selected, highlight first option
      var _this$props = _this.props,
          options = _this$props.options,
          isOpeningUpward = _this$props.isOpeningUpward;

      var currentIndex = _this.state.highlightedOptionIndex;
      var index = 0;
      if (currentIndex !== null) {
        index = currentIndex;
      } else if (_this.props.selectedOptionValue) {
        index = options.findIndex(function (option) {
          return option.value === _this.props.selectedOptionValue;
        });
      }
      if (isOpeningUpward) return options.length - 1 - index;
      return index;
    }, _this.setHighlightedOptionIndex = function (optionIndex) {
      if (!_this.isHighlightedOption(optionIndex) && _this.isDisabledOption(optionIndex)) {
        _this.setState({ highlightedOptionIndex: optionIndex });
      }
    }, _this.isHighlightedOption = function (optionIndex) {
      return _this.state.highlightedOptionIndex === optionIndex;
    }, _this.isDisabledOption = function (optionIndex) {
      var options = _this.props.options;

      var option = options[optionIndex];
      return option && !option.isDisabled;
    }, _this.handleClickOnOption = function (option, event) {
      if (option) {
        if (option.isDisabled) return;
        if (_this.props.onChange) _this.props.onChange(option, event);
      }
      if (_this.props.onBlur) _this.props.onBlur(event);
      _this.close();
    }, _this._handleSelectionOnEnterKey = function (event) {
      var options = _this.props.options;

      if (options.length) {
        var isOpeningUpward = _this.props.isOpeningUpward;

        var currentIndex = _this.state.highlightedOptionIndex;
        var reverseIndex = options.length - 1 - currentIndex;
        var highlightedOption = options[isOpeningUpward ? reverseIndex : currentIndex];
        _this.handleClickOnOption(highlightedOption, event);
      } else {
        event.preventDefault();
      }
    }, _this._handleHighlightMove = function (currentIndex, direction) {
      var options = _this.props.options;

      if (options.length) {
        var lowerIndexBound = 0;
        var upperIndexBound = options.length - 1;
        var newIndex = direction === 'up' ? currentIndex - 1 : currentIndex + 1;

        // Make sure new index is within options bounds
        newIndex = Math.max(lowerIndexBound, Math.min(newIndex, upperIndexBound));

        if (options[newIndex].isDisabled) {
          // Try to jump over disabled options
          var canMoveUp = newIndex > lowerIndexBound;
          var canMoveDown = newIndex < upperIndexBound;
          if (direction === 'up' && canMoveUp || direction === 'down' && canMoveDown) {
            _this._handleHighlightMove(newIndex, direction);
          }
        } else {
          _this.setHighlightedOptionIndex(newIndex);
        }
      } else {
        event.preventDefault();
      }
    }, _this._handleKeyDown = function (event) {
      var highlightOptionIndex = _this.state.highlightedOptionIndex;
      switch (event.keyCode) {
        case 9:
          // Select currently highlighted option on Tab key
          event.preventDefault();
          _this._handleSelectionOnEnterKey(event);
          break;
        case 13:
          // Select currently highlighted option on Enter key
          _this._handleSelectionOnEnterKey(event);
          break;
        case 27:
          // Close on Escape key
          _this.close();
          break;
        case 38:
          // Move selection higlight 'up' on Arrow Up key
          event.preventDefault(); // prevent caret move
          _this._handleHighlightMove(highlightOptionIndex, 'up');
          break;
        case 40:
          // Move selection higlight 'down' on Arrow Down key
          event.preventDefault(); // prevent caret move
          _this._handleHighlightMove(highlightOptionIndex, 'down');
          break;
        default:
          _this.props.resetOnClose && _this.setHighlightedOptionIndex(0);
      }
    }, _this._handleDocumentClick = function (event) {
      var root = _this._getRootSkinPart();
      var isDescendant = _events2.default.targetIsDescendant(event, _reactDom2.default.findDOMNode(root));
      if (_this.state.isOpen && !isDescendant) {
        _this.close();
      }
    }, _this._handleWindowResize = function () {
      return _this.state.isOpen && _this.close();
    }, _this._handleScroll = function () {
      return _this.state.isOpen && _this.close();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Options, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.isOpen !== nextProps.isOpen) {
        this.updateComponentsStates(nextProps.isOpen, null);
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      // update isOpen state when parent component force open / close options
      // (e.g. click on Input in Select component)
      if (!this.state.isOpen && nextState.isOpen) {
        window.addEventListener('resize', this._handleWindowResize);
        this.handleScrollEventListener('add');
        _events2.default.addEventsToDocument(this._getDocumentEvents());
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState.isOpen && !this.state.isOpen) this.removeAllEventListeners();

      if (this.props.isOpen !== prevProps.isOpen) {
        var rootNode = this._getRootSkinPart();
        var parentNode = rootNode.parentNode;
        var parentNodeParams = parentNode.getBoundingClientRect();

        var positionY = void 0;
        if (this.props.isOpeningUpward) {
          positionY = window.innerHeight - parentNodeParams.top - 14;
        } else {
          positionY = parentNodeParams.bottom + 20;
        }

        var position = {
          width: parentNodeParams.width,
          positionX: parentNodeParams.left,
          positionY: positionY
        };
        this.updateComponentsStates(this.props.isOpen, position);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.state.isOpen) this.removeAllEventListeners();
    }
  }, {
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Options.prototype.__proto__ || Object.getPrototypeOf(Options.prototype), 'prepareSkinProps', this).call(this, props), {
        isOpen: this.state.isOpen,
        highlightedOptionIndex: this.state.highlightedOptionIndex,
        position: this.state.position
      });
    }
  }, {
    key: 'removeAllEventListeners',
    value: function removeAllEventListeners() {
      _events2.default.removeEventsFromDocument(this._getDocumentEvents());
      window.removeEventListener('resize', this._handleWindowResize);
      this.handleScrollEventListener('remove');
    }

    // ========= PRIVATE HELPERS =========

  }, {
    key: '_getDocumentEvents',
    value: function _getDocumentEvents() {
      return {
        keydown: this._handleKeyDown,
        click: this._handleDocumentClick,
        touchend: this._handleDocumentClick,
        scroll: this._handleScroll
      };
    }
  }, {
    key: '_getRootSkinPart',
    value: function _getRootSkinPart() {
      return this.skinParts[Options.SKIN_PARTS.OPTIONS];
    }
  }]);

  return Options;
}(_SkinnableComponent3.default), _class.SKIN_PARTS = {
  OPTIONS: 'options'
}, _class.propTypes = Object.assign({}, _SkinnableComponent3.default.propTypes, {
  isOpen: _propTypes2.default.bool,
  isOpeningUpward: _propTypes2.default.bool,
  resetOnClose: _propTypes2.default.bool, // reset highlighted option on options close (e.g. in autocomplete)
  optionRenderer: _propTypes2.default.func,
  selectedOptionValue: _propTypes2.default.string,
  noResults: _propTypes2.default.bool,
  noResultsMessage: _props.LabelProp
}), _class.defaultProps = {
  isOpen: false,
  isOpeningUpward: false,
  resetOnClose: false,
  noResultsMessage: 'No results'
}, _temp2);
exports.default = Options;
//# sourceMappingURL=Options.js.map