'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = (_temp2 = _class = function (_FormField) {
  _inherits(Select, _FormField);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isOpen: false
    }, _this.focus = function () {
      return _this.toggleOptions();
    }, _this.onCloseOptions = function () {
      _this.setState({ isOpen: false });
    }, _this.handleInputClick = function (event) {
      event.stopPropagation();
      event.preventDefault();
      _this._getInputSkinPart().blur();
      _this.toggleOptions();
    }, _this.handleChange = function (option, event) {
      if (_this.props.onChange) _this.props.onChange(option.value, event);
      _this.toggleOptions();
    }, _this.getSelectedOption = function () {
      var _this$props = _this.props,
          options = _this$props.options,
          value = _this$props.value,
          allowBlank = _this$props.allowBlank;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;

          if (option.value === value) return option;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!allowBlank) return options[0];
    }, _this.toggleOptions = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // Handle props used strictly for Select parent element which is in this case Input.
  // Other props (Options props) are same for different parent elements and must be handled on one place - Options


  _createClass(Select, [{
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Select.prototype.__proto__ || Object.getPrototypeOf(Select.prototype), 'prepareSkinProps', this).call(this, props), {
        isOpen: this.state.isOpen
      });
    }

    // ========= PUBLIC SKIN API =========

    // Focus the component - toggle dropdown

  }, {
    key: '_getInputSkinPart',


    // ========= PRIVATE HELPERS =========

    value: function _getInputSkinPart() {
      return this.skinParts[Select.SKIN_PARTS.INPUT];
    }
  }]);

  return Select;
}(_FormField3.default), _class.SKIN_PARTS = {
  ROOT: 'root',
  INPUT: _Input2.default.SKIN_PARTS.INPUT
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.string.isRequired,
    isDisabled: _propTypes2.default.bool
  })).isRequired,
  value: _propTypes2.default.string,
  allowBlank: _propTypes2.default.bool,
  placeholder: _propTypes2.default.string
}), _class.defaultProps = {
  allowBlank: true
}, _temp2);
exports.default = Select;
//# sourceMappingURL=Select.js.map